#include <aknnotewrappers.h>
#include "python.h"
#include "symbian_python_ext_util.h"

#include "notewrap.h"

_LIT8(KErrorNoteType, "error");
_LIT8(KInfoNoteType, "info");
_LIT8(KConfNoteType, "conf");

extern "C" PyObject * 
note(PyObject *args) 
{ 
  TInt error = KErrNone; 
  int l_tx, l_ty; 
  char *b_tx, *b_ty; 

  if (!PyArg_ParseTuple(args, "u#s#", &b_tx, &l_tx, &b_ty, &l_ty))
  return NULL; 

  TPtrC8 stype((TUint8*)b_ty, l_ty); 
  TPtrC note_text((TUint16 *)b_tx, l_tx); 
  CAknResourceNoteDialog* dlg = NULL; 

  
  if (stype.Compare(KErrorNoteType) == 0) 
    dlg = new CAknErrorNote(ETrue); 
  else if (stype.Compare(KInfoNoteType) == 0) 
    dlg = new CAknInformationNote(ETrue); 
  else if (stype.Compare(KConfNoteType) == 0) 
    dlg = new CAknConfirmationNote(ETrue); 
  else { 
    PyErr_BadArgument(); 
    return NULL; 
  } 

  if (dlg == NULL) 
    return PyErr_NoMemory(); 

  Py_BEGIN_ALLOW_THREADS 
  TRAP(error, dlg->ExecuteLD(note_text)); 
  Py_END_ALLOW_THREADS 

  if (error != KErrNone) 
    return SPyErr_SetFromSymbianOSErr(error); 
  else { 
    Py_INCREF(Py_None); 
    return Py_None; 
  } 
}
